osl::checkmate::PawnCheckmateMoves Struct Reference

`#include <pawnCheckmateMoves.h>`

## Static Public Member Functions

template<Player P>
static bool | effectiveOnlyIfPawnCheckmate (Ptype ptype, Square from, Square to)
| 指手は打歩詰の時以外は試さなくて良い TODO: 敵陣2段目の香も打歩詰以外は成るべき
static bool | effectiveOnlyIfPawnCheckmate (Player a, Ptype ptype, Square from, Square to)
static bool | effectiveOnlyIfPawnCheckmate (Move m)
static bool | hasParingNoPromote (bool isPromote, Ptype ptype)
static bool | hasParingNoPromote (Move m)
| m を不成にした指手は打歩詰の時以外は試さなくて良い.

## Detailed Description

Definition at line 11 of file pawnCheckmateMoves.h.

## Member Function Documentation

## effectiveOnlyIfPawnCheckmate() [1/3]

bool osl::checkmate::PawnCheckmateMoves::effectiveOnlyIfPawnCheckmate | ( | Move | m | ) |

inline static

Definition at line 30 of file pawnCheckmateMoves.h.

References effectiveOnlyIfPawnCheckmate(), osl::Move::from(), osl::Move::player(), osl::Move::ptype(), and osl::Move::to().

## effectiveOnlyIfPawnCheckmate() [2/3]

bool osl::checkmate::PawnCheckmateMoves::effectiveOnlyIfPawnCheckmate | ( | Player | a,
|  | Ptype | ptype,
|  | Square | from,
|  | Square | to )

inline static

Definition at line 24 of file pawnCheckmateMoves.h.

References osl::BISHOP, osl::Square::canPromote(), osl::PAWN, and osl::ROOK.

## effectiveOnlyIfPawnCheckmate() [3/3]

template<Player P>

bool osl::checkmate::PawnCheckmateMoves::effectiveOnlyIfPawnCheckmate | ( | Ptype | ptype,
|  | Square | from,
|  | Square | to )

inline static

指手は打歩詰の時以外は試さなくて良い TODO: 敵陣2段目の香も打歩詰以外は成るべき

Definition at line 18 of file pawnCheckmateMoves.h.

References osl::BISHOP, osl::Square::canPromote(), osl::PAWN, and osl::ROOK.

Referenced by effectiveOnlyIfPawnCheckmate().

## hasParingNoPromote() [1/2]

bool osl::checkmate::PawnCheckmateMoves::hasParingNoPromote | ( | bool | isPromote,
|  | Ptype | ptype )

inline static

Definition at line 36 of file pawnCheckmateMoves.h.

References osl::PBISHOP, osl::PPAWN, and osl::PROOK.

Referenced by hasParingNoPromote().

## hasParingNoPromote() [2/2]

bool osl::checkmate::PawnCheckmateMoves::hasParingNoPromote | ( | Move | m | ) |

inline static

m を不成にした指手は打歩詰の時以外は試さなくて良い.

m を不成にした指手が王手とは限らない

Definition at line 45 of file pawnCheckmateMoves.h.

References hasParingNoPromote(), osl::Move::isPromotion(), and osl::Move::ptype().

The documentation for this struct was generated from the following file:

- pawnCheckmateMoves.h